下一个大数问题(cont)

问题: Next Greater Element I

You are given two arrays (without duplicates) nums1 and nums2 where nums1’s elements are subset of nums2. Find all the next greater numbers for nums1's elements in the corresponding places of nums2.

The Next Greater Number of a number x in nums1 is the first greater number to its right in nums2. If it does not exist, output -1 for this number.

Input:

  • 数组nums1, nums1 是 nums2 的subset :: int[]
  • 数组nums2 :: int[]

Output:

  • 找到nums1中每个数下一个比它大的数在nums2中的位置(下一个是指位置上的下一个不是数值大小的下一个) :: int[]

Intuition:

像这种在一个array里面找比每个元素或大或小的问题,直觉上想不是用stack就是用two pointer。但素,这个题它不一样,他有两个array,两array全都塞进一个stack? 显然不太可能? 这时候再看题目,nums1 是 nums2 的subset 这句话就很可疑了, 所以我们需要的nums1的数在nums2里都能找到,也就是说题目已经帮我们把需要塞stack的数放到一个array里了,也就是nums2. nums1的作用就只是在最终得结果的时候的一个索引而已。

stack自己显然没有记录信息的功能,那么在stack出入栈的时候需要一个数据结构来存储我们需要的信息:(数,比它大的数的index), key-value pair对不对?那么我们需要一个map。

Code:

TC: O(n) SC: O(n)

public int nextGreaterI(int[] nums1, int nums2){
  HashMap<Integer, Integer> map = new HashMap<>();
  Deque<Integer> stk = new ArrayDeque<>();

  for (int i = 0; i < nums2.length; i++){
    while(!stk.isEmpty() && stk.peek() < nums2[i]){
      // (n, index of nums just greater than n)
      map.put(stk.pop(), nums2[i]);
    }  
    stk.push(nums[i]);
  }
  //update index of next greater number
  for (int i = 0; i < nums1.length; i++){
    nums[i] = map.getOrDefault(nums[i], -1);
  }
  return nums1;
}

问题: Next Greater Element II

Given a circular array (the next element of the last element is the first element of the array), print the Next Greater Number for every element. The Next Greater Number of a number x is the first greater number to its traversing-order next in the array, which means you could search circularly to find its next greater number. If it doesn't exist, output -1 for this number.

Input:

  • 数组nums :: int[]

Output:

  • 找到nums中每个数下一个比它大的数(注意不是index了阿) :: int[]

Intuition:

这题就在array的数量上是正常了,就一个array没跑了stack塞它就对了。但是眼神不好的同学(比如本渣我)往往看不到之前的“circular”,对的,它就是一个圈。也就是说最后一个数的next greater element可以是第一个数,想想看pixel的那个黄黄的球体吃豆豆的游戏~(= ̄ω ̄=)

也就是说只扫一遍array是不够的,那就扫两遍。。。是的就是这种谜之惯性的直觉往往可以crack很多tricky的问题。再咋circular两遍也cover所有可能了吧?

Code:

TC: O(2 * n) SC: O(n)

public int nextGreaterII(int[] nums){
  HashMap<Integer, Integer> map = new HashMap<>();
  Deque<Integer> stk = new ArrayDeque<>();

  for (int i = 0; i < nums.length * 2; i++){
    int cur = nums[i % nums.length];
    while(!stk.isEmpty() && stk.peek() < cur){
      // (n, nums just greater than n)
      map.put(stk.pop(), cur);
    }  
    stk.push(cur);
  }
  for (int i = 0; i < nums.length; i++){
    nums[i] = map.getOrDefault(nums[i], -1);
  }
  return nums;
}

问题: Next Greater Element III

Given a positive 32-bit integer n, you need to find the smallest 32-bit integer which has exactly the same digits existing in the integer n and is greater in value than n. If no such positive 32-bit integer exists, you need to return -1.

Input:

  • 一个数 :: int

Output:

  • 找到数位相同的比这个数大的下一个数(这里是指数值上下一个大的数):: int

Intuition:

我发现1337里这种有3个followup的题,等到了第三个题的时候总是一言不合就画风突变。说好的stack解法呢摔?没错,这是一道permuation题。与next permuation那道题一毛一样,就是人家给的是数组,你把它变成数组不就完了嘛,换汤不换药~~ 是的,我又要偷懒了( ̄▽ ̄)~, 详细的解释可以参考那道题,直接上代码~

Code

TC: O(n) SC: O()

public int NextGreaterElementIII(int n){
   String input = String.valueOf(n);
        char[] cs = input.toCharArray();
        
        int p = 0;
        for (int i = cs.length - 2; i >= 0; i--){
            if (cs[i] < cs[i + 1]){
                p = i;
                break;
            }
        }
        
        int q = 0;
        for (int j = cs.length - 1; j >= 0; j--){
            if (cs[j] > cs[p]){
                q = j;
                break;
            }
        }
        
        if ((p == 0 && q == 0) || n >= Integer.MAX_VALUE){
            return -1;
        }
        
        char temp = cs[p];
        cs[p] = cs[q];
        cs[q] = temp;
        
        reverse(cs, p + 1, cs.length - 1);
        long res = Long.parseLong(new String(cs));
        return res > Integer.MAX_VALUE? -1 : (int) res;
}

Reference

https://leetcode.com/problems/next-greater-element-i/
https://leetcode.com/problems/next-greater-element-ii/description/
https://leetcode.com/problems/next-greater-element-iii/

最后编辑于
©著作权归作者所有,转载或内容合作请联系作者
  • 序言:七十年代末,一起剥皮案震惊了整个滨河市,随后出现的几起案子,更是在滨河造成了极大的恐慌,老刑警刘岩,带你破解...
    沈念sama阅读 203,772评论 6 477
  • 序言:滨河连续发生了三起死亡事件,死亡现场离奇诡异,居然都是意外死亡,警方通过查阅死者的电脑和手机,发现死者居然都...
    沈念sama阅读 85,458评论 2 381
  • 文/潘晓璐 我一进店门,熙熙楼的掌柜王于贵愁眉苦脸地迎上来,“玉大人,你说我怎么就摊上这事。” “怎么了?”我有些...
    开封第一讲书人阅读 150,610评论 0 337
  • 文/不坏的土叔 我叫张陵,是天一观的道长。 经常有香客问我,道长,这世上最难降的妖魔是什么? 我笑而不...
    开封第一讲书人阅读 54,640评论 1 276
  • 正文 为了忘掉前任,我火速办了婚礼,结果婚礼上,老公的妹妹穿的比我还像新娘。我一直安慰自己,他们只是感情好,可当我...
    茶点故事阅读 63,657评论 5 365
  • 文/花漫 我一把揭开白布。 她就那样静静地躺着,像睡着了一般。 火红的嫁衣衬着肌肤如雪。 梳的纹丝不乱的头发上,一...
    开封第一讲书人阅读 48,590评论 1 281
  • 那天,我揣着相机与录音,去河边找鬼。 笑死,一个胖子当着我的面吹牛,可吹牛的内容都是我干的。 我是一名探鬼主播,决...
    沈念sama阅读 37,962评论 3 395
  • 文/苍兰香墨 我猛地睁开眼,长吁一口气:“原来是场噩梦啊……” “哼!你这毒妇竟也来了?” 一声冷哼从身侧响起,我...
    开封第一讲书人阅读 36,631评论 0 258
  • 序言:老挝万荣一对情侣失踪,失踪者是张志新(化名)和其女友刘颖,没想到半个月后,有当地人在树林里发现了一具尸体,经...
    沈念sama阅读 40,870评论 1 297
  • 正文 独居荒郊野岭守林人离奇死亡,尸身上长有42处带血的脓包…… 初始之章·张勋 以下内容为张勋视角 年9月15日...
    茶点故事阅读 35,611评论 2 321
  • 正文 我和宋清朗相恋三年,在试婚纱的时候发现自己被绿了。 大学时的朋友给我发了我未婚夫和他白月光在一起吃饭的照片。...
    茶点故事阅读 37,704评论 1 329
  • 序言:一个原本活蹦乱跳的男人离奇死亡,死状恐怖,灵堂内的尸体忽然破棺而出,到底是诈尸还是另有隐情,我是刑警宁泽,带...
    沈念sama阅读 33,386评论 4 319
  • 正文 年R本政府宣布,位于F岛的核电站,受9级特大地震影响,放射性物质发生泄漏。R本人自食恶果不足惜,却给世界环境...
    茶点故事阅读 38,969评论 3 307
  • 文/蒙蒙 一、第九天 我趴在偏房一处隐蔽的房顶上张望。 院中可真热闹,春花似锦、人声如沸。这庄子的主人今日做“春日...
    开封第一讲书人阅读 29,944评论 0 19
  • 文/苍兰香墨 我抬头看了看天上的太阳。三九已至,却和暖如春,着一层夹袄步出监牢的瞬间,已是汗流浃背。 一阵脚步声响...
    开封第一讲书人阅读 31,179评论 1 260
  • 我被黑心中介骗来泰国打工, 没想到刚下飞机就差点儿被人妖公主榨干…… 1. 我叫王不留,地道东北人。 一个月前我还...
    沈念sama阅读 44,742评论 2 349
  • 正文 我出身青楼,却偏偏与公主长得像,于是被迫代替她去往敌国和亲。 传闻我的和亲对象是个残疾皇子,可洞房花烛夜当晚...
    茶点故事阅读 42,440评论 2 342

推荐阅读更多精彩内容